################################################################################
#
# Copyright 2014
# Author Imran Shakir
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# which accompanies this distribution, and is available at
# http://www.eclipse.org/legal/epl-v10.html
#
# Contributors:
# Imran Shakir - initial implementation
#
################################################################################
require 'iib'
require 'iib/node/CLI'
require 'iib/node/REST'

require 'mixlib/shellout'

module IIB
  module Node

    def self.new(options)
      return IIB::Node::REST.new(options) if options.has_key?(:hostname)
      return IIB::Node::CLI.new(options)  if options.has_key?(:name)
    end

    def self.get_all_local_nodes
      IIB.check_local_iib_environment

      iib_list = Mixlib::ShellOut.new("iib list -d 0")
      iib_list.run_command

      output = iib_list.stdout
      matches = output.scan(/BIP8099I:\ Broker:\ ([^\ ]*)\ \ -\ \ ([^\n]*)/m)

      matches.map do |match|
        IIB::Node.new(type: :CLI,name: match[0])
      end
    end

    def self.create_local_node(name)
      IIB.check_local_iib_environment

      iib_create_broker = Mixlib::ShellOut.new("iib createbroker #{name}")
      iib_create_broker.run_command

      return IIB::Node.new(type: :CLI, name: name)
    end

    def self.delete_local_node(name)
      IIB.check_local_iib_environment

      iib_delete_broker = Mixlib::ShellOut.new("iib deletebroker #{name}")

      iib_delete_broker.run_command
    end

  end
end