################################################################################
#
# Copyright 2014
# Author Imran Shakir
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Eclipse Public License v1.0
# which accompanies this distribution, and is available at
# http://www.eclipse.org/legal/epl-v10.html
#
# Contributors:
# Imran Shakir - initial implementation
#
################################################################################
require 'mixlib/shellout'

require 'iib'

module IIB
  module Node
    class CLI
      include IIB::Node

      attr_reader :name

      def initialize(options)
        @name = options[:name]
      end

      def is_running
        IIB.check_local_iib_environment
        iib_list = Mixlib::ShellOut.new("iib list")
        iib_list.run_command

        iib_list.stdout.lines.each do |line|
          return true if line =~ /^BIP1325I.*'#{name}'.*$/
          return false if line =~ /^BIP1326I.*'#{name}'.*$/
        end
      end

      def start 
        IIB.check_local_iib_environment
        iib_start = Mixlib::ShellOut.new("iib start #{name}")
        iib_start.run_command
      end

      def stop
        IIB.check_local_iib_environment
        iib_stop = Mixlib::ShellOut.new("iib stop #{name}")
        iib_stop.run_command
      end

      def ==(other_object)
        return name == other_object.name
      end

      private

      def strip_mqsi_command_response(stdout)
        matches = stdout =~ /^.*\n(.*)\n.*$/
      end

    end
  end
end